//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "GridUtil.h"
#include "pairsform.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{

   WriteRowColumnHeaders();
   GridSelectCell(this, 1,1,true);

}
//---------------------------------------------------------------------------
void TForm1::WriteRowColumnHeaders(void)
{
   AnsiString s;


     // row header information
    for(int jj = 1;jj < Grid->ColCount;jj++)
    {
      Grid->Cells[0][jj] = IntToStr(jj);
    }

      // col header information
    for(int jj = 1,kk = 'A' ;jj < Grid->RowCount;jj++,kk++)
    {
      if(jj % 27 == 0)
         kk = 'A';

      s = AnsiString::StringOfChar(kk, 1);

      Grid->Cells[jj][0] = s;

    }

    for(int jj = 27,kk = 'A' ;jj < Grid->RowCount;jj++)
    {
      s = Grid->Cells[jj][0];
      String ss = AnsiString::StringOfChar(kk, 1);
      ss += s;
      Grid->Cells[jj][0] = ss;
    }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{

   if(bChanged == true)
   {

      if( MessageBox(Application->Handle,"You have not saved the new data - are you sure you want to exit without saving?",
         "Constrained Array Test System - Pairs Generator",
         MB_YESNO|MB_ICONWARNING|MB_DEFBUTTON2) == IDNO)
      {  /*     if (MessageDlg("You have not saved the new data - are you sure you want to exit without saving?",
              mtConfirmation,TMsgDlgButtons() << mbOK << mbCancel,0) == mrCancel)

        */
         CanClose = false;
      }
   }
   else
      CanClose = true;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NewExecute(TObject *Sender)
{
   if(bChanged == true)    // if user has not saved...
   {
      if(MessageBox(Application->Handle,"You have not saved the new data - are you sure you want to start a new session?","Constrained Array Test System - Pairs Generator",        MB_YESNO|MB_ICONWARNING|MB_DEFBUTTON2) == IDNO)
        /*     if (MessageDlg("You have not saved the new data - are you sure you want to exit without saving?",            mtConfirmation,TMsgDlgButtons() << mbOK << mbCancel,0) == mrCancel)       */
        return; // return without clearing
      else     // they chose to go ahead
      {  ClearGrid(Grid);
         bChanged = false;
         iLastRow = iLastCol = 0;
      }
   }
   else     // no changes since saving....
   {
      ClearGrid(Grid);   // not using the Clear method since it clears ALL cells
                     // including my label header rows/cols
      bChanged = false;
      iLastRow = iLastCol = 0;
   }


}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TForm1::SaveExecute(TObject *Sender)
{
   AnsiString s;

   TStringList* List = new TStringList;

   List->Clear();

   iLastRow =  GetLastUsedRow(Grid,50,50);   //assumes start at row/col 1
   iLastCol =  GetLastUsedColumn(Grid,50,50);   //assumes start at row/col 1

   TSaveDialog*   SaveDialog1 = new TSaveDialog(Application);

    for(int iRow = 1;iRow <= iLastRow;iRow++)
    {
        for(int iCol = 1;iCol <= iLastCol;iCol++)
        {
           if(Grid->Cells[iCol][iRow] == "")
            Grid->Cells[iCol][iRow] = " ";

           List->Add(Grid->Cells[iCol][iRow]);
        }
         // ok, should be last col of this row, so special END string
        List->Add(".$$$");


    }

    // should be all in the list now..so save it to file
      SaveDialog1->Title = "Constrained Array Test System - Pairs Generator";
      SaveDialog1->Filter = "CATS files (*.cts)|*.cts|Text files (*.txt)|*.txt";
      SaveDialog1->DefaultExt = ".cts";
      if (SaveDialog1->Execute())
      {
         List->SaveToFile(SaveDialog1->FileName);
         bChanged = false;
      }

    delete SaveDialog1;
    List->Clear();
    delete List;


}
//---------------------------------------------------------------------------

void __fastcall TForm1::GridSetEditText(TObject *Sender, int ACol,
      int ARow, const AnsiString Value)
{
   // update variables to store the last row and column that
   // were edited, and thus SHOULD contain data.

   if(ACol > iLastCol)
      iLastCol = ACol;
   if(ARow > iLastRow)
      iLastRow = ARow;


}
//---------------------------------------------------------------------------

void __fastcall TForm1::GridKeyPress(TObject *Sender, char &Key)
{
   // update the grid 'DIRTY' flag
   bChanged = true;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::LoadExecute(TObject *Sender)
{
   AnsiString s,strLine;
   int  iRow = 1;
   int  iCol = 1;

   TStringList* List = new TStringList;

   TOpenDialog*   OpenDialog1 = new TOpenDialog(this);

   List->Clear();

    OpenDialog1->Title = "Constrained Array Test System - Pairs Generator";
    OpenDialog1->Filter = "CATS files (*.cts)|*.cts|Text files (*.txt)|*.txt";
    OpenDialog1->DefaultExt = ".cts";
    if (OpenDialog1->Execute())
    {
       List->LoadFromFile(OpenDialog1->FileName);
       bChanged = false;

       for(int jj = 0;jj < List->Count;jj++)
       {
           strLine = List->Strings[jj];

           if(strLine == ".$$$")
           {
               iRow++;
               iCol = 1;
               continue;

           }

           Grid->Cells[iCol++][iRow] = strLine;

      }


    }



    Grid->Refresh();
    delete OpenDialog1;
    List->Clear();
    delete List;
    iLastRow = GetLastUsedRow(Grid,50,50);   //assumes start at row/col 1
    iLastCol = GetLastUsedColumn(Grid,50,50);   //assumes start at row/col 1


}
//---------------------------------------------------------------------------




void __fastcall TForm1::GridSelectCell(TObject *Sender, int ACol, int ARow,
      bool &CanSelect)
{
   String R,S;

   S = Grid->Cells[ACol][0];
   S += Grid->Cells[0][ARow];

   StatusBar1->Panels->Items[0]->Text = "Row " + IntToStr(ARow) + " Column " + IntToStr(ACol);
   StatusBar1->Panels->Items[1]->Text = S;
}
//---------------------------------------------------------------------------



void __fastcall TForm1::GeneratePairsExecute(TObject *Sender)
{
   iLastRow = GetLastUsedRow(Grid,50,50);
   iLastCol = GetLastUsedColumn(Grid,50,50);

   frmPairs->Show();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::WindowClose1Execute(TObject *Sender)
{
   Close();   
}
//---------------------------------------------------------------------------

