 /***************************************************************
 *
 * Unit Name:  GridUtil.cpp
 * Purpose  :  Basic grid support to TStringGrid and TCoolStringGrid objects
 * Author   :  Martin Fensome
 * History  :  Created                                   Jan 19, 2001
 *
 ****************************************************************/


//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <grids.hpp>

#include "GridUtil.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)


 /***************************************************************
 *
 *
 * Function name: GetLastUsedRow
 * Unit name:     GridUtil.cpp
 * Date/Time:     1/20/01 7:18:35 PM
 * Purpose:       To return the last row of the grid that has data in it.
 * History:
 *
 ****************************************************************/
int GetLastUsedRow(TStringGrid* Grid,int maxrow,int maxcol,int startrow,int startcol)
{
   int   iLastRow = 0;
   int   iMaxRow  = 0;


  // start rows at default 1 assumes there is a header row with labels

  for(int iRow = startrow;iRow < maxrow;iRow++)
  {
     for(int iCol = startcol;iCol <= maxcol;iCol++)
     {
         //String ss = Grid->Cells[iCol][iRow];
       if(Grid->Cells[iCol][iRow] != "" && Grid->Cells[iCol][iRow] != " ")
       {
           iLastRow = iRow;
           if(iLastRow > iMaxRow)
            iMaxRow = iLastRow;

       }
     }

  }


return iMaxRow;

}
//---------------------------------------------------------------------------
 /***************************************************************
 *
 *
 * Function name: GetLastUsedColumn
 * Unit name:     GridUtil.cpp
 * Date/Time:     1/20/01 7:18:35 PM
 * Purpose:       To return the last column of the grid that has data in it.
 * History:
 *
 ****************************************************************/
int GetLastUsedColumn(TStringGrid* Grid,int maxrow,int maxcol,int startrow,int startcol)
{
   int   iLastCol = 0;
   int   iMaxCol  = 0;


  for(int iRow = startrow;iRow < maxrow;iRow++)
  {
     for(int iCol = startcol;iCol <= maxcol;iCol++)
     {
         //String ss = Grid->Cells[iCol][iRow];
       if(Grid->Cells[iCol][iRow] != "" && Grid->Cells[iCol][iRow] != " ")
       {
           iLastCol = iCol;
           if(iLastCol > iMaxCol)
            iMaxCol = iLastCol;

       }
     }

  }


return iMaxCol;

}

//---------------------------------------------------------------------------
 /***************************************************************
 *
 *
 * Function Name: ClearGrid
 * Unit name:     GridUtil.cpp
 * Date/Time:     1/20/01 11:47:17 PM
 * Purpose:       To clear grid
 * History:
 *
 ****************************************************************/
void ClearGrid(TStringGrid* Grid)
{
 AnsiString s;

 //assume start at row/col 1 so that header info is not lost.

  for(int iRow = 1;iRow <= Grid->RowCount;iRow++)
  {
    for(int iCol = 1;iCol <= Grid->ColCount;iCol++)
       Grid->Cells[iCol][iRow] = "";
  }



}
